--[[
URadio Script by Megiddo
Check our site out at http://ulyssesmod.net/
]]

local stations = {
["Afterhours DJs"] = "http://www.surfmusic.de/radio-station/afterhours-djs-dsl,7599.html",
["The End"] = "http://www.surfmusic.de/radio-station/kenz-101-9-the-end,8180.html",
["Oldies"] = "http://www.surfmusic.de/radio-station/kqxx-oldies-105-5,8843.html",
["Dance"] = "http://www.surfmusic.de/radio-station/knrj-energy-92-7-fm-dsl,5305.html",
["Blues"] = "http://www.surfmusic.de/radio-station/koqx-dsl,7823.html",
["The Beat"] = "http://www.surfmusic.de/radio-station/kibt-96-1-the-beat,5434.html",
["Country"] = "http://www.surfmusic.de/radio-station/kccy-y96-9,8842.html",
["Jazz"] = "http://www.surfmusic.de/radio-station/kuvo-89-3-fm,5451.html",
}

local res = [["radio"
{
	"window"
	{
		"ControlName"		"Frame"
		"fieldName"		"window"
		"xpos"		"489"
		"ypos"		"400"
		"zpos"		"290"
		"wide"		"600"
		"tall"		"320"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"settitlebarvisible"		"1"
		"title"		"URadio Menu"
		"sizable"		"0"
	}
	"divider"
	{
		"ControlName"		"Divider"
		"fieldName"		"divider"
		"xpos"		"20"
		"ypos"		"90"
		"wide"		"560"
		"tall"		"2"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
	}
	"stop"
	{
		"ControlName"		"Button"
		"fieldName"		"stop"
		"xpos"		"250"
		"ypos"		"30"
		"zpos"		"290"
		"wide"		"100"
		"tall"		"40"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Stop Music"
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"about:blank"
		"Default"		"0"
	}
]]

local mul = 0
for name, url in pairs( stations ) do
	mul = mul + 1
	local mulx = math.floor( (mul-1) / 4 ) -- Make rows of 4
	local muly = math.fmod( mul-1, 4 )
	res = res .. [[
	"]] .. mul .. [["
	{
		"ControlName"		"Button"
		"fieldName"		"]] .. mul .. [["
		"xpos"		"]] .. 30 + mulx*110 .. [["
		"ypos"		"]] .. muly*50 + 110 .. [["
		"zpos"		"290"
		"wide"		"100"
		"tall"		"40"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"]] .. name .. [["
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"]] .. url .. [["
		"Default"		"0"
	}
]]
end

res = res .. "}"

local menu

local function routeCommand( panel, type, command )
	LocalPlayer():ConCommand( string.format( "music \"%s\"\n", command ) )
	menu:SetVisible( false )
end

function showRadio()
	if menu then menu:SetVisible( true ) return end

	menu = vgui.Create( "Frame" )
	menu:SetName( "window" )
	
	local button = vgui.Create( "Button", menu, "stop" )
	button:SetActionFunction( routeCommand )

	for i=1, table.Count( stations ) do
		local button = vgui.Create( "Button", menu, i )
		button:SetActionFunction( routeCommand )
	end


	menu:LoadControlsFromString( res )
	menu:SetKeyBoardInputEnabled( true )
	menu:SetMouseInputEnabled( true )

	menu:SetPos( ScrW()*0.3, ScrH()-400 )
	menu:SetVisible( true )
end
concommand.Add( "radio", showRadio )